function StreetAssistant(argFromPusher) {
this.MainAssistant = Mojo.Controller.getAppController().assistant;
this.position = argFromPusher;
}

StreetAssistant.prototype = {
	setup: function() {
		Ares.setupSceneAssistant(this);
		
		this.SdragStartHandler = this.SdragStart.bindAsEventListener(this);
		this.SdraggingHandler = this.Sdragging.bindAsEventListener(this);
		if (Mojo.Environment.DeviceInfo.platformVersionMajor == "2" && Mojo.Environment.DeviceInfo.platformVersionMinor == "2") {

		//Mojo.Log.info("WebOS 2.2.x detected", Mojo.Environment.DeviceInfo.platformVersion);
		Mojo.Event.listen(this.controller.stageController.document, Mojo.Event.dragStart, this.SdragStartHandler);
		Mojo.Event.listen(this.controller.stageController.document, Mojo.Event.dragging, this.SdraggingHandler);
		
		};

         
         //****
         
this.controller.setupWidget("StreetSpinner",
  this.attributes = {
      spinnerSize: "large"
  },
  this.model = {
      spinning: true
  }
);
         
var menuModel = {
  visible: true,
  items: [
      {
          items: [
              
          ]
      }, 
      {
          items: [
              {label: $L('Minus'), iconPath:'images/zoomout.png', command:'zoomOut'},
              { icon: "back", command: "goBack"},
              {label: $L('Plus'), iconPath:'images/zoomin.png', command:'zoomIn'}              
          ]
      },
      {
          items: [
          ]
      }
  ]
};
         
         //****

     this.controller.setupWidget(Mojo.Menu.commandMenu,
         this.attributes = {
             spacerHeight: 0,
             menuClass: 'no-fade'
         },
         menuModel
     );   

		
// Check for a street view at the position
this.streetViewCheck = new google.maps.StreetViewService();  
this.streetViewCheck.getPanoramaByLocation(this.position, 50, function(result, status) {
		//Mojo.Log.info("STATUS", status);
    if (status == google.maps.StreetViewStatus.ZERO_RESULTS) {
        this.streetViewAvailable = false;  
        this.handleZEROResponse();    
    }else{
        this.streetViewAvailable = true;
        this.Panorama();
    }
}.bind(this));


	},
	
handleZEROResponse: function(response) {

				this.controller.get('StreetSpinner').mojo.stop();
				$('overlay-scrim').hide();
         this.controller.showAlertDialog({
            onChoose: function(value) {
            
               this.controller.stageController.popScene();
            },
            title: $L("Street View not available"),
            message: $L("Street View is not available for this location."),
            choices: [{
               label: $L("OK"),
               value: ""
            }]
         });
},
	
Panorama: function() {
       

       
       var panoramaOptions = {
				  position: this.position,
				  visible: true,
				  addressControl: true,
				  linksControl: true,
				  panControl: false,
				  zoomControl: false,
				  enableCloseButton: false,
				  pov: {
				    heading: 34,
				    pitch: 10,
				    zoom: 1
				  			}
			};

this.controller.get('StreetSpinner').mojo.stop(); //stop spinner
$('overlay-scrim').hide();

this.panorama = new google.maps.StreetViewPanorama(document.getElementById("street_canvas"), panoramaOptions);

},
	
	 handleCommand: function(event) {
                if (event.type === Mojo.Event.command) {
                        if (event.command == 'goBack') {
                        this.controller.stageController.popScene();

                        }
                        if (event.command == 'zoomOut') { 
                                        this.panorama.setPov({ heading: this.panorama.getPov().heading, pitch: this.panorama.getPov().pitch, zoom: this.panorama.getPov().zoom-1 });

                        }
                        if (event.command == 'zoomIn') { 
                                        this.panorama.setPov({ heading: this.panorama.getPov().heading, pitch: this.panorama.getPov().pitch, zoom: this.panorama.getPov().zoom+1 });
                        }
                }
  },
  
SdragStart: function(event) {

            this.oldx = event.down.x;
            this.oldy = event.down.y; 
            //Mojo.Log.info("** DRAG has started ***", this.oldx, this.oldy);
        },
        
Sdragging: function(event) {
        //var difference = [this.oldx - event.move.x, this.oldy - event.move.y];
    				this.headingoffset = this.oldx - event.move.x;
    				this.pitchoffset = this.oldy - event.move.y;

        this.panorama.setPov({ heading: this.panorama.getPov().heading + this.headingoffset, pitch: this.panorama.getPov().pitch - this.pitchoffset, zoom: this.panorama.getPov().zoom });

        this.oldx = event.move.x;
        this.oldy = event.move.y;
},
	cleanup: function() {	
	 if (Mojo.Environment.DeviceInfo.platformVersionMajor == "2" && Mojo.Environment.DeviceInfo.platformVersionMinor == "2") {
		Mojo.Event.stopListening(this.controller.stageController.document, Mojo.Event.dragStart, this.SdragStartHandler);
		Mojo.Event.stopListening(this.controller.stageController.document, Mojo.Event.dragging, this.SdraggingHandler);
		};
		Ares.cleanupSceneAssistant(this);
	}
};